/* Written by Amir Israeli  July 2000  Email: israelaq@walla.co.il
  No warranty of any kind , Documentation will be present in www.amir-israeli.tripod.com/index.html
 next month (August 2000) , Don't  remove this header */
// NewFileMenu.cpp: implementation of the CNewFileMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RegistryShell.h"
#include "NewFileMenu.h"
#include "ShellExecute.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


class CNewFileInformation  
{
public:
	CNewFileInformation();
	virtual ~CNewFileInformation();

	BOOL CreateNewFile( LPCTSTR lpszDirectory);

public:
	BOOL SetFileOfTypeNull();
	BOOL SetFileOfTypeTemplate( LPCTSTR lpszTemplateName);
	BOOL SetFileOfTypeCommand( LPCTSTR lpszCommandName);
	BOOL SetFileOfTypeData( LPBYTE pData, DWORD cbData = 0);
	BOOL SetFileOfTypeDirectory();
	BOOL SetInfo( int iIndex, LPCTSTR lpszDescription, LPCTSTR lpszExtension);

protected:
	BOOL CreateNullFile( LPCTSTR lpszDirectory, CString *pStrOut = NULL);
	BOOL CreateFileFromData( LPCTSTR lpszDirectory);
	BOOL CreateFileFromTemplate( LPCTSTR lpszDirectory);
	BOOL CreateFileFromCommand( LPCTSTR lpszDirectory);
	BOOL CreateNewDirectory( LPCTSTR lpszDirectory);
	CString GetTemplateDir();

#ifdef _DEBUG
	void msg( LPCTSTR lpszText = NULL, LPCTSTR lpszTitle = NULL) {
		CMessage::msg( lpszText, lpszTitle);
	}
#endif

public:
	int GetCode(){ return iCode; }
	
	int SetCommand(int iNewCommand){ return iCommand = iNewCommand; } 
	int GetCommand(){ return iCommand; }
	void SetDescription( LPCTSTR lpszDescription) {	strDescription = lpszDescription; }
	void SetExtension( LPCTSTR lpszExtension) { strExtension =  lpszExtension; }
	CString GetDescription(){  return strDescription; }
	CString GetExtension(){  return strExtension; }

protected:

	CString GetProperDirectory( LPCTSTR lpszDirectory);

protected:
	int iCommand;//command of menu that is associated with this item
	CString strDescription;
	CString strExtension;
	int iCode; //1=NULLFILE 2=FILENAME (template)
			   //3=COMMAND  4=DATA
			   //5=New Directory
	CString strData;
	//if iCode==2 then this is the name of the template
	//if iCode==3 then this is the command
	LPBYTE  pData;
	DWORD cbData;//bytes count in pData
	int iIcon;
};


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CNewFileMenu::CNewFileMenu()
{
	m_NewFiles.SetSize(0,1);	
}
CNewFileMenu::~CNewFileMenu()
{
	Destroy();
}

void CNewFileMenu::Destroy()
{
	for (int nCount = m_NewFiles.GetSize() , i = nCount-1 ; i>=0 ; i--) {
		delete m_NewFiles.GetAt(i);
	}
	m_NewFiles.RemoveAll();
}

BOOL CNewFileMenu::CreateItem( int iCommand, LPCTSTR lpszDirectory)
{
	CWaitCursor wait;
	int iSize = m_NewFiles.GetSize();
	if ((iCommand >= iSize) || (iCommand<0)) //not in range
		return FALSE;

	CNewFileInformation *pInfo = m_NewFiles.GetAt(iCommand);
	if (!pInfo) 
		return FALSE;

	++iCommand;//all commands ids were inserted to menu as GetSize() + 1 (size of array)

	if (pInfo->GetCommand() == iCommand)
		return pInfo->CreateNewFile( lpszDirectory);
	return FALSE;
}

//////////////////////////////////////////////////////////////
//////////
BOOL CNewFileMenu::Create()
{
	CWaitCursor wait;
	Destroy();

//////// from refresh /////////	
	CRegistryShell reg;
	CStringArray  arrExtentions,arrTmp;
	arrExtentions.SetSize(0,1);
	arrTmp.SetSize(0,1);
	reg.EnumFileExtensions(&arrExtentions);
	
	CString strShellNew=_T("ShellNew"),strKey;

	//gets the data of every key in key list
	for (int iTotal=arrExtentions.GetSize(),i=0 ; i<iTotal ; i++ ) {
		strKey = arrExtentions.GetAt(i);
		if ((reg.EnumRecursive( strKey, &arrTmp)) &&
			(reg.DeletePathWhichNotIncludes( strShellNew, &arrTmp)) &&
			(arrTmp.GetSize()))
		{
			EnumShellNewOfSingleKey( strKey, &arrTmp);
		}
		arrTmp.RemoveAll();//delete all items to go to the next item
	}
//////////////////////////////
	//here all extensions were enumerated , now Adding "New Folder" 
	//item to the database of items
//////////Inserting Directory
	int iCommand = m_NewFiles.GetSize() + 1;
	
	CString strCaption = _T("New Folder"), data = _T("");
	CString strPath = _T("HKEY_CLASSES_ROOT\\Folder");

	reg.GetValueDefault( strPath, &strCaption);
	if (!strCaption.GetLength()) strCaption = _T("Folder");

	AddCommand( iCommand , 5 , strCaption,
		data , data , NULL , 0); // 5 == code of new folder

	SetIconsOfNewFileMenu();
	return TRUE;
}
BOOL CNewFileMenu::AddCommand(int iNewCommand, int iCode , 
		LPCTSTR lpszDescription, LPCTSTR lpszExtension, LPCTSTR lpszData, 
		BYTE *pData , DWORD cbData)
{
	if ((iCode<=0) || (iCode>5)) //invalid code
		return FALSE;//checking to be sure

	CNewFileInformation *pInfo = new CNewFileInformation;
	if (!pInfo)  return FALSE;

	if (!pInfo->SetInfo( iNewCommand, lpszDescription, lpszExtension)) {
		delete pInfo;
		return FALSE;
	}

	//1=NULLFILE 2=FILENAME (template) 
	//3=COMMAND  4=DATA	 5=New Directory
	switch (iCode)
	{
	case 1:	pInfo->SetFileOfTypeNull();	break;
	case 2:	pInfo->SetFileOfTypeTemplate(lpszData);	break;
	case 3:	pInfo->SetFileOfTypeCommand(lpszData);	break;
	case 4:	pInfo->SetFileOfTypeData( pData, cbData);  break;
	case 5:	pInfo->SetFileOfTypeDirectory();	break;
	}

	m_NewFiles.Add(pInfo);
	return TRUE;
}


BOOL CNewFileMenu::EnumShellNewOfSingleKey( LPCTSTR lpszKey, CStringArray *pPaths)
{
	if (!lpszKey)  
		return FALSE; // got Null key
	CString strCurrentPath , key = lpszKey;
	if (!DealSpecialFlags( lpszKey, pPaths))  return FALSE;

	int iTotalPaths = pPaths->GetSize();
	//may be more than 1 path to ShellNew , every one needs 
	//to be taken care properly
	for (int i=0 ; i<iTotalPaths ; i++)	{
		strCurrentPath = pPaths->GetAt(i);
		if (!strCurrentPath.IsEmpty())
			FindDataOfKey( lpszKey, strCurrentPath, iTotalPaths);
	}
	return TRUE;
}
BOOL CNewFileMenu::DealSpecialFlags( LPCTSTR lpszKey, CStringArray *paths)
{
	CRegistryShell reg;
	CString strKey = lpszKey;
	//check the default value for that key to see whether
	CString strDefVal;//it has something or not
	if (!reg.GetValueDefault( strKey, &strDefVal))  
		return FALSE;

	if (strDefVal.IsEmpty())  return FALSE;//dont add extensions
	// that dont have default description in that value
	if ((paths->GetSize()>1) && (!reg.DeletePathWhichNotIncludes( strDefVal, paths)))
		return FALSE;

	if (!paths->GetSize())//no paths are left
		return FALSE;
	
	return TRUE;//there are some paths left
}

BOOL CNewFileMenu::FindDataOfKey( LPCTSTR lpszKey, LPCTSTR lpszCurrentPath, int iPathsCount)
{
	CRegistry reg;
	CString strCaption, strExtension;
	//not able to get extension or it is null
	if (!reg.GetLastLevel( lpszKey, &strExtension))
		return FALSE; //not able to get caption or it is null
	if (strExtension.IsEmpty())  return FALSE;

	if (!FindCaption( lpszKey, lpszCurrentPath, &strCaption, iPathsCount))
		return FALSE;

	int iCode = 1;
	CString strData;
	LPBYTE  p = NULL;
	DWORD   dwCount = 0,dwType = 0;

	if (!GetBuildData( lpszKey, &iCode, lpszCurrentPath, &strData, p, &dwType, &dwCount))  return FALSE;

	//Adding this item to the database of items
	int iCommand = m_NewFiles.GetSize() +1;
	AddCommand( iCommand , iCode ,strCaption, strExtension ,strData ,p,dwCount);

	return FALSE;
}

BOOL CNewFileMenu::GetBuildData( LPCTSTR lpszKey, int *piCode,
		LPCTSTR lpszCurrentPath, CString *pstrCommandData, LPBYTE &p,
		DWORD *pdwType,DWORD *pdwCount)
{
	CRegistry reg;
	CString arrCreationTypes[] = { _T("NullFile"),_T("FileName"),_T("Command"),_T("Data") };
	CString strShellPath = lpszCurrentPath;

	LPBYTE pData = NULL;
	DWORD  dwDataType = 0, dwBytesCount = 0;
	int result = 0, code = 0;
	CString strData;

	CString hh;
	for (int i=0 ; ((i<4) && (!result)) ; i++ )	{
		result = ( (i != 3) ? (reg.GetValueString( strShellPath, arrCreationTypes[i], &strData))
							: (reg.GetValue( strShellPath, arrCreationTypes[i], &pData, &dwDataType, &dwBytesCount)) );
		if (result)  code=i+1;
	}

	if ((!result) || (!code)) {
		if (pData) {
			delete [] pData;
			pData = NULL;
		}
		return FALSE;
	}
	
	*piCode = code;
	if (code==4) { //this file item is created with data
		p = pData;
		*pdwType = dwDataType;
		*pdwCount = dwBytesCount;
	}
	else if (code>0)  
		*pstrCommandData = strData; //created by template or command

	return TRUE;
}

BOOL CNewFileMenu::FindCaption( LPCTSTR lpszKey, LPCTSTR lpszCurrentPath,CString *pstrCaptionOut,int iPathsCount)
{
	CRegistry reg;
	CString strKey = lpszKey, strShellNewPath= lpszCurrentPath;
	CString strShellNew = _T("ShellNew"), root=_T("HKEY_CLASSES_ROOT");

	CString strCaption;//description of key
	if (!reg.GetValueDefault( lpszKey, &strCaption)) return FALSE;
	
	//check 2 cases : (both have title)
	//1)  most common : 1 path that is also the default one
	//2)  many paths , checking if this is the default one
	if (((iPathsCount>1) && (strCaption.GetLength()) 
		&& (reg.IsExistKey( &strCaption,&strShellNewPath)))
		|| ((iPathsCount==1) && (strCaption.GetLength())))
	{
		//this is the default key therefore load its caption 
		//(the current caption is pointer to true one)
		CString curRoot = _T("HKEY_CLASSES_ROOT");
		reg.AppendPath( &curRoot, strCaption);
		if (!reg.GetValueDefault( curRoot, &strCaption)) return FALSE;
		*pstrCaptionOut = strCaption;
		return TRUE;
	}

	//this happens when we select non-default file whenever we 
	//have multiple files on the same key
	if (iPathsCount>1) {
		CString curRoot = _T("HKEY_CLASSES_ROOT");
		reg.GetLevelBeforeLevel( strShellNewPath, strShellNew, &strCaption);
		reg.AppendPath( &curRoot, strCaption);
		if (!reg.GetValueDefault( curRoot, &strCaption)) return FALSE;
		*pstrCaptionOut=strCaption;
		return TRUE;
	}

	if (reg.CountLevels( strShellNewPath)>2) {
		reg.GetLevelBeforeLevel( strShellNewPath, strShellNew, &strCaption);
		for (int x=0 ; x<strCaption.GetLength() ; x++)
			if ((strCaption[x]>=_T('A')) && (strCaption[x]<=_T('Z') && (strCaption[x] != _T('\0')))) {
				strCaption.Insert(x,_T(' '));
				x+=2;
			}
		*pstrCaptionOut = strCaption;
		return TRUE;
	}
	return FALSE;
}

BOOL CNewFileMenu::SetIconsOfNewFileMenu()
{
/*

//CString s;
	int iSize = m_NewFiles.GetSize();
	for (int i=0 ; i<iSize ; i++)
	{
		CString extension;
		UINT uID = m_NewFiles.GetID(i);
		if (m_NewFiles.GetExtension(i,extension))
		{
			SHFILEINFO sfi;
			UINT uFlags=SHGFI_SYSICONINDEX | SHGFI_ATTRIBUTES | SHGFI_USEFILEATTRIBUTES ;
			::ZeroMemory(&sfi,sizeof(sfi));
			::SHGetFileInfo( extension ,0, &sfi ,sizeof(sfi), uFlags ); 

//s.Format("check index %d \" %s\" ico=%d id=%u",i,extension,sfi.iIcon,uID);
//msg(s);
			(extension.GetLength()) ? SetBitmapID(uID,sfi.iIcon)
						: SetBitmapID(uID,3);
		}
	} //end for

	SetBitmapID(0,3);
	SetBitmapID(-1,3);
*/
	return TRUE;
}

HMENU CNewFileMenu::InternalCreateMenu(BOOL bPopupMenu)
{
	return (bPopupMenu) ? (::CreatePopupMenu()) : (::CreateMenu());
}

#define MAX_ITEM_IN_MENU 25

//The caller MUST DELETE the menu himself
HMENU CNewFileMenu::GetMenu( int iFirstCommand, BOOL bPopupMenu)
{
	HMENU  m_hMainMenu , m_hCurrentMenu;
	int iCurrentCommand = iFirstCommand;
	m_hMainMenu = InternalCreateMenu(bPopupMenu);
	if (!::IsMenu(m_hMainMenu))  return NULL;
	m_hCurrentMenu = m_hMainMenu;

	int iSize = m_NewFiles.GetSize();
	CNewFileInformation *pInfo;

	for (int i=0 ; i<iSize ; i++ ) {
		pInfo = m_NewFiles.GetAt(i);
		if (pInfo) {
			CString strDescription = pInfo->GetDescription();
			CString strExtension = pInfo->GetExtension();
			int iCode = pInfo->GetCode();
			int iCommand = pInfo->GetCommand();

			if (iCode == 5) {
				InsertMenu( m_hMainMenu, 0, MF_BYPOSITION|MF_STRING, iCurrentCommand++, strDescription);
			}
			else if (!strExtension.CompareNoCase(_T(".lnk"))) {	
				//inserting link to first handle
				int iCount = ::GetMenuItemCount(m_hCurrentMenu);
				if (iCount>=2)
					InsertMenu( m_hMainMenu, 1, MF_BYPOSITION|MF_STRING, iCurrentCommand++, strDescription);
				else  AppendMenu( m_hMainMenu, MF_STRING, iCurrentCommand++, strDescription);
			}
			else AppendMenu( m_hCurrentMenu, MF_STRING, iCurrentCommand++, strDescription);

			//adding new submenu to this menu
			if (::GetMenuItemCount(m_hCurrentMenu) == MAX_ITEM_IN_MENU) { //creating another item to insert into it
				HMENU m_hNewMenu = InternalCreateMenu(bPopupMenu);
				if (!::IsMenu(m_hNewMenu)) {
					::DestroyMenu(m_hMainMenu);
					return NULL;
				}
				::AppendMenu( m_hCurrentMenu, MF_SEPARATOR, 0, _T(""));
				::AppendMenu( m_hCurrentMenu, MF_POPUP|MF_STRING, (UINT)m_hNewMenu, _T("..."));
				m_hCurrentMenu = m_hNewMenu;
			}

		}//info was got
	}//end for loop
	
	// separator after 2 items (like in explorer)
	InsertMenu( m_hMainMenu, 2, MF_BYPOSITION|MF_SEPARATOR, 0, _T(""));

	return m_hMainMenu;
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
////////  CNewFileInformation class


CNewFileInformation::CNewFileInformation()
{
	iCode = iCommand = 0;
	iIcon = -1;
	pData = NULL;
	cbData = 0;
}
CNewFileInformation::~CNewFileInformation()
{
	iCode = iCommand = 0;
	if (pData)  delete [] pData;
}
//////////////////////////////////////////////////////////
////////// Function to set info of New Item
BOOL CNewFileInformation::SetInfo( int iIndex, LPCTSTR lpszDescription, LPCTSTR lpszExtension)
{
	SetCommand(iIndex);
	SetDescription( lpszDescription);
	SetExtension( lpszExtension);
	return TRUE;
}
BOOL CNewFileInformation::SetFileOfTypeNull()
{
	iCode = 1;
	return TRUE;
}
BOOL CNewFileInformation::SetFileOfTypeTemplate( LPCTSTR lpszTemplateName)
{
	iCode = 2;
	strData = lpszTemplateName;
	return TRUE;
}
BOOL CNewFileInformation::SetFileOfTypeCommand( LPCTSTR lpszCommandName)
{
	iCode = 3;
	strData = lpszCommandName;
	return TRUE;
}
BOOL CNewFileInformation::SetFileOfTypeData( LPBYTE pData, DWORD cbData)
{
	iCode = 4;
	this->pData = pData;
	this->cbData = cbData;
	return TRUE;
}
BOOL CNewFileInformation::SetFileOfTypeDirectory()
{
	iCode = 5;
	return TRUE;
}
////////////////////////////////////////////////////////////
/////////// Functions to create the files
BOOL CNewFileInformation::CreateNewFile( LPCTSTR lpszDirectory)
{
	switch (iCode)
	{
	case 1: return CreateNullFile( lpszDirectory);
	case 2: return CreateFileFromTemplate( lpszDirectory);
	case 3: return CreateFileFromCommand( lpszDirectory);
	case 4: return CreateFileFromData( lpszDirectory);
	case 5: return CreateNewDirectory( lpszDirectory);
	}
	return FALSE;
}

BOOL CNewFileInformation::CreateNullFile( LPCTSTR lpszDirectory, CString *pStrOut)
{
	CString strPath , strBackupDir , strName , strNew = _T("New");
	strPath= lpszDirectory;

	CRegistry reg;
	reg.Trim(&strPath); // getting the current directory and
	if (!strPath.GetLength())  return FALSE; //"backing" it up
	strBackupDir = strPath;

	int iIndex = 1;
	HANDLE hFile=NULL;

	do {
		(iIndex==1) ?  strName.Format("%s %s%s",strNew,strDescription,strExtension) :
			 strName.Format("%s %s (%d)%s",strNew, strDescription,iIndex,strExtension);
		reg.AppendPath(&strPath , strName);

		hFile=::CreateFile( strPath ,GENERIC_READ|GENERIC_WRITE ,
			 FILE_SHARE_READ|FILE_SHARE_WRITE , NULL,CREATE_NEW, FILE_ATTRIBUTE_NORMAL,NULL);

		if (hFile != INVALID_HANDLE_VALUE) {
			::CloseHandle(hFile);
			if (pStrOut)
				*pStrOut = strName ;
			return TRUE;
		}
	
		iIndex++;
		strPath = strBackupDir; //setting back the directory

		if ((iIndex) && (!(iIndex%10000)))
			reg.msg( _T("Error creating New file\t\nwait for another attempts ..."), _T("Error"));
	} while (iIndex<29000);

	return FALSE;
}

BOOL CNewFileInformation::CreateFileFromData( LPCTSTR lpszDirectory)
{
	CString strDir = lpszDirectory , strFileName ;
	if (!CreateNullFile( lpszDirectory, &strFileName))  
		return FALSE;
	if (strFileName.IsEmpty()) return FALSE; //check if data was
	if (strDir.IsEmpty()) return FALSE;//initialized

	CString strPath = strDir;
	CRegistry reg;
	reg.AppendPath( &strPath, strFileName);
	
	HANDLE hFile= ::CreateFile( strPath ,GENERIC_READ|GENERIC_WRITE ,
			FILE_SHARE_READ|FILE_SHARE_WRITE , NULL, OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL,NULL);
	if (!hFile) return FALSE; //file not opened
	DWORD dwWritten = 0;

	BOOL bResult = ::WriteFile( hFile, pData, cbData, &dwWritten, NULL);
	::CloseHandle(hFile);
	return bResult;
}
BOOL CNewFileInformation::CreateFileFromTemplate( LPCTSTR lpszDirectory)
{
	CString strTemplateDir = GetTemplateDir();
	if (strTemplateDir.IsEmpty())  
		return FALSE;

	CString strDir = lpszDirectory , strFileName ;
	if (!CreateNullFile( lpszDirectory, &strFileName))  
		return FALSE;
	if (strFileName.IsEmpty()) return FALSE; //check if data was
	if (strDir.IsEmpty()) return FALSE;//initialized

	CString strTemplateName = strData;
	//is template name initialized ?
	if (strTemplateName.IsEmpty())  
		return FALSE;

	//checking whether the template name is a relative path
	//or a static path (in ShellNew template directory or in
	//any different (hard-coded) directory : (power point
	//uses hard coded path)

	CRegistry reg;
	reg.AppendPath( &strDir , strFileName);
	CString strTemplatePath;
	int iFind = strTemplateName.ReverseFind(_T('\\'));
	if (iFind==-1) { //Shell new directory
	    strTemplatePath = strTemplateDir;	
		CRegistry reg;
		reg.AppendPath( &strTemplatePath, strTemplateName);
	}
	else //hard coded directory  use this directory
		strTemplatePath = strTemplateName;
	return ::CopyFile( strTemplatePath , strDir , FALSE);
}
BOOL CNewFileInformation::CreateFileFromCommand( LPCTSTR lpszDirectory)
{
	CString strCommand = strData; //coping to new string
	return CShellExecute::Command( strCommand);
}

CString CNewFileInformation::GetProperDirectory( LPCTSTR lpszDirectory)
{
	CString strDir = lpszDirectory;
	if (strDir.IsEmpty()) {
		TCHAR lpBuff[MAX_PATH*2];
		::GetCurrentDirectory( sizeof(lpBuff), lpBuff);
		strDir = (LPCTSTR)lpBuff;
	}
	return strDir;
}
BOOL CNewFileInformation::CreateNewDirectory( LPCTSTR lpszDirectory)
{
	CString backupName=_T("New Folder"), name = backupName;

	CString	strCurrentDir = GetProperDirectory(lpszDirectory);
	CRegistry reg;
	reg.Trim(&strCurrentDir);

	CString strFullName = strCurrentDir;
	reg.AppendPath( &strFullName, name);
	BOOL bResult= ::CreateDirectory(strFullName,NULL);

	if (bResult==TRUE) return TRUE;
	int iCounter=2;
	do {
		name.Format("%s (%d)",backupName,iCounter++);
		strFullName = strCurrentDir;
		reg.AppendPath( &strFullName, name);
		bResult= ::CreateDirectory( strFullName, NULL);
	}
	while ((!bResult) && (iCounter<24000));
	return ((bResult==TRUE) ? 1 : 0 );
}

//This function looks into registry (works in every version)
//another is call GetSpecialFolderLocation( ...)
CString CNewFileInformation::GetTemplateDir()
{
	CString strTemplatesDirectory;
	CString strRegPath = _T("HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders");
	CString strRegValue = _T("Templates");
	
	CRegistry reg;
	if (reg.GetValueString( strRegPath, strRegValue, &strTemplatesDirectory))
		return strTemplatesDirectory;
	
	return _T("");//failed
}





