/* Written by Amir Israeli  July 2000  Email: israelaq@walla.co.il
  No warranty of any kind , Documentation will be present in www.amir-israeli.tripod.com/index.html
 next month (August 2000) , Don't  remove this header */
// RegistryShell.cpp: implementation of the CRegistryShell class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RegistryShell.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRegistryShell::CRegistryShell()
{
}
CRegistryShell::~CRegistryShell()
{
}
///////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////
////////  DeletePathWhichNotIncludes function
BOOL CRegistryShell::DeletePathWhichNotIncludes( LPCTSTR lpszKey, CStringArray *pArrKeyNames, int iLevelRequired)
{
	CString tmp, strWanted = lpszKey;
	for (int iCount = pArrKeyNames->GetSize(),i=iCount-1 ; i>=0 ; i-- ) {
		tmp = pArrKeyNames->GetAt(i);
		if (!IsExistKey( &strWanted, &tmp,iLevelRequired))
				pArrKeyNames->RemoveAt(i,1);
	}
	return TRUE;
}

///////////////////////////////////////////////////////////
////////
BOOL CRegistryShell::EnumFileExtensions(CStringArray *pArrKeyNames)
{
	BOOL bFullPath=TRUE;
	CString strRegPath=_T("HKEY_CLASSES_ROOT");
	if (!Enum1Level( &strRegPath, pArrKeyNames, bFullPath))  return 0;
	int iCount = pArrKeyNames->GetSize();
	CString strPath;
	for (int i=iCount-1,place ; i>=0 ; i--) {
		strPath = pArrKeyNames->GetAt(i);
		if ((strPath.GetLength()) && ((place=strPath.Find(_T('\\')))!=-1)) {
			if (strPath.GetAt(place+1) != _T('.'))   
				pArrKeyNames->RemoveAt(i,1);
		}
	}
	return TRUE;
}
///////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////
////////
BOOL CRegistryShell::CheckForShellNew(CStringArray *pArrKeyNames)
{
	CWaitCursor wait;
	CStringArray arr,arrShellNewPaths;
	CString	 strPath,strShellNew=_T("ShellNew");
	arr.SetSize(0,1);
	arrShellNewPaths.SetSize(0,1);

	pArrKeyNames->RemoveAll();
	if (!EnumFileExtensions(pArrKeyNames))  return 0;
	
	for (int iCount = pArrKeyNames->GetSize(),i = iCount-1 ; i>=0 ; i-- ) {
		strPath = pArrKeyNames->GetAt(i);
		if (GetShellNewOfItem( strPath, &arr))
				arrShellNewPaths.Append(arr);
	}	
	pArrKeyNames->RemoveAll();
	pArrKeyNames->Append(arrShellNewPaths);
	return TRUE;
}
BOOL CRegistryShell::GetShellNewOfItem( LPCTSTR lpszKey, CStringArray *pArrKeyNames)
{
	CString strPath = lpszKey, strShellNew=_T("ShellNew");
	Trim(&strPath);
	pArrKeyNames->RemoveAll();
	if (!EnumRecursive( lpszKey, pArrKeyNames))  return 0;
	if (!DeletePathWhichNotIncludes( strShellNew, pArrKeyNames))  return 0;
	return TRUE;
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////
///// output full names of keys
BOOL CRegistryShell::EnumRecursive( LPCTSTR lpszKey, CStringArray *pArrKeyNames, BOOL bFullPath,int iMaxLevels)
{
	CWaitCursor  wait;
	return EnumRecursiveInternal(lpszKey, pArrKeyNames, bFullPath, iMaxLevels, 0);
}
BOOL CRegistryShell::EnumRecursiveInternal( LPCTSTR lpszKey, CStringArray *pArrKeyNames, BOOL bFullPath,int iMaxLevels,int iLevelCount)
{
	if ((iMaxLevels) && (iLevelCount>iMaxLevels)) 
		return TRUE;

	CString strBackUp = lpszKey, strPath2Use = strBackUp;
	HKEY hRootKey,hNewKey;
	if (!FormulatePath(&strPath2Use,&hRootKey))  return FALSE;
	if (!Open(hRootKey,&strPath2Use,&hNewKey))   return FALSE;

	TCHAR lpszBuff[MAX_PATH*2];
	DWORD dwNameSize;
    DWORD i=0;

	for (LONG result = ERROR_SUCCESS ; 
		((result==ERROR_SUCCESS) && (result!=ERROR_NO_MORE_ITEMS)) ;
		  i++)
	{
		dwNameSize = sizeof(lpszBuff);
		result = ::RegEnumKeyEx( hNewKey, i, lpszBuff, &dwNameSize,NULL,NULL ,NULL ,NULL);
        if (result == (DWORD)ERROR_SUCCESS) //suceeded getting name
        {
			CString tmp = strBackUp;
			AppendPath( &tmp, (LPCTSTR)lpszBuff);
			
			if (!bFullPath) //dont add full path
					pArrKeyNames->Add((LPCTSTR)lpszBuff);
			else	pArrKeyNames->Add(tmp);

			//enumerating the sub key that was just got
			EnumRecursiveInternal( tmp, pArrKeyNames, bFullPath, iMaxLevels, ++iLevelCount);
		}
	}//end "for"

	Close(hNewKey);
	return TRUE;
}

///////////////////////////////////////////////////////////








