/* Written by Amir Israeli  July 2000  Email: israelaq@walla.co.il
  No warranty of any kind , Documentation will be present in www.amir-israeli.tripod.com/index.html
 next month (August 2000) , Don't  remove this header */
// ShellExecute.cpp: implementation of the CShellExecute class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NewFileMenuApp.h"
#include "ShellExecute.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CShellExecute::CShellExecute()
{
}

CShellExecute::~CShellExecute()
{
}

BOOL CShellExecute::FormulatePath( LPCTSTR lpszSrc, CString &strCommand, CString &strParams)
{
	CString strSrc = lpszSrc;
	strSrc.TrimLeft(_T(' '));	strSrc.TrimRight(_T(' '));
	strSrc.TrimLeft(_T('\\'));	strSrc.TrimRight(_T('\\'));
	strSrc.TrimLeft(_T(' '));	strSrc.TrimRight(_T(' '));

	if (strSrc.IsEmpty())
		return FALSE; //no command

	int iFind = strSrc.Find( _T("%1"), 0);
	if (iFind >=0) {
		strSrc.SetAt( iFind, _T('c'));
		strSrc.SetAt( iFind+1, _T(':'));
		strSrc.Insert( iFind+2, _T('\\'));
	}

	int nCmdLen = strSrc.Find(_T(' '));
	if (nCmdLen == -1) {
		nCmdLen = strSrc.GetLength();
	}

	strParams= strSrc.Mid(nCmdLen);
	strParams.TrimLeft(_T(' '));  strParams.TrimRight(_T(' '));

	strCommand = strSrc.Left(nCmdLen);
	return TRUE;
}

BOOL CShellExecute::Command( LPCTSTR lpszCommand, BOOL bShowError)
{
	CString strCommand, strParams;
	if (FormulatePath( lpszCommand, strCommand, strParams)) {
		return Exec( _T("Open"), strCommand, strParams, bShowError);
	}
	return FALSE;
}
BOOL CShellExecute::Print( LPCTSTR lpszShellPath, BOOL bShowError)
{
	if (!lpszShellPath) 
		return FALSE;
	return Exec( _T("Print"), lpszShellPath, NULL, bShowError);
}

///////////////////////////////////////////////////////////////
BOOL CShellExecute::Exec(LPCTSTR lpszVerb,LPCTSTR lpszCommand,LPCTSTR lpszParams,BOOL bShowError)
{
	HINSTANCE hinst = ::ShellExecute(AfxGetMainWnd()->m_hWnd ,
		lpszVerb ,lpszCommand , lpszParams , NULL,SW_SHOWDEFAULT );
	if (bShowError)
		Error((UINT)hinst);
	return ((UINT)hinst>32);
}
void CShellExecute::Error( UINT hHinstanceCode)
{
    // If the command failed to run, tell the user.
    if (hHinstanceCode < HINSTANCE_ERROR) {
		::MessageBox(::GetDesktopWindow(), _T("Command failed to execute"), 
         _T("Networker Application") , MB_ICONSTOP | MB_OK);
    }
}




